OpenVDB: PointDataLeafNode< T, Log2Dim > Class Template Reference

OpenVDB 8.0.0

Public Types | Public Member Functions | Static Public Attributes | Protected Types | Friends | List of all members
PointDataLeafNode< T, Log2Dim > Class Template Reference

`#include <PointDataGrid.h>`

## Public Types
using | LeafNodeType = PointDataLeafNode< T, Log2Dim >
using | Ptr = std::shared_ptr< PointDataLeafNode >
using | ValueType = T
using | ValueTypePair = std::pair< ValueType, ValueType >
using | IndexArray = std::vector< ValueType >
using | Descriptor = AttributeSet::Descriptor
using | BaseLeaf = tree::LeafNode< T, Log2Dim >
using | NodeMaskType = util::NodeMask< Log2Dim >
using | ValueOn = typename BaseLeaf::ValueOn
using | ValueOff = typename BaseLeaf::ValueOff
using | ValueAll = typename BaseLeaf::ValueAll
using | ValueOnIter = typename BaseLeaf::template ValueIter< MaskOnIterator, PointDataLeafNode, const ValueType, ValueOn >
using | ValueOnCIter = typename BaseLeaf::template ValueIter< MaskOnIterator, const PointDataLeafNode, const ValueType, ValueOn >
using | ValueOffIter = typename BaseLeaf::template ValueIter< MaskOffIterator, PointDataLeafNode, const ValueType, ValueOff >
using | ValueOffCIter = typename BaseLeaf::template ValueIter< MaskOffIterator, const PointDataLeafNode, const ValueType, ValueOff >
using | ValueAllIter = typename BaseLeaf::template ValueIter< MaskDenseIterator, PointDataLeafNode, const ValueType, ValueAll >
using | ValueAllCIter = typename BaseLeaf::template ValueIter< MaskDenseIterator, const PointDataLeafNode, const ValueType, ValueAll >
using | ChildOnIter = typename BaseLeaf::template ChildIter< MaskOnIterator, PointDataLeafNode, ChildOn >
using | ChildOnCIter = typename BaseLeaf::template ChildIter< MaskOnIterator, const PointDataLeafNode, ChildOn >
using | ChildOffIter = typename BaseLeaf::template ChildIter< MaskOffIterator, PointDataLeafNode, ChildOff >
using | ChildOffCIter = typename BaseLeaf::template ChildIter< MaskOffIterator, const PointDataLeafNode, ChildOff >
using | ChildAllIter = typename BaseLeaf::template DenseIter< PointDataLeafNode, ValueType, ChildAll >
using | ChildAllCIter = typename BaseLeaf::template DenseIter< const PointDataLeafNode, const ValueType, ChildAll >
using | IndexVoxelIter = IndexIter< ValueVoxelCIter, NullFilter >
using | IndexAllIter = IndexIter< ValueAllCIter, NullFilter >
using | IndexOnIter = IndexIter< ValueOnCIter, NullFilter >
using | IndexOffIter = IndexIter< ValueOffCIter, NullFilter >

## Public Member Functions
| PointDataLeafNode ()
| Default constructor. More...
| ~PointDataLeafNode ()=default
| PointDataLeafNode (const PointDataLeafNode &other)
| Construct using deep copy of other PointDataLeafNode. More...
| PointDataLeafNode (const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
| Construct using supplied origin, value and active status. More...
| PointDataLeafNode (const PointDataLeafNode &other, const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
template<typename OtherValueType >
| PointDataLeafNode (const tools::PointIndexLeafNode< OtherValueType, Log2Dim > &other)
template<typename ValueType >
| PointDataLeafNode (const tree::LeafNode< ValueType, Log2Dim > &other, const T &value, TopologyCopy)
template<typename ValueType >
| PointDataLeafNode (const tree::LeafNode< ValueType, Log2Dim > &other, const T &, const T &, TopologyCopy)
| PointDataLeafNode (PartialCreate, const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
const AttributeSet & | attributeSet () const
| Retrieve the attribute set. More...
AttributeSet::UniquePtr | stealAttributeSet ()
| Steal the attribute set, a new, empty attribute set is inserted in it's place. More...
void | initializeAttributes (const Descriptor::Ptr &descriptor, const Index arrayLength, const AttributeArray::ScopedRegistryLock *lock=nullptr)
| Create a new attribute set. Existing attributes will be removed. More...
void | clearAttributes (const bool updateValueMask=true, const AttributeArray::ScopedRegistryLock *lock=nullptr)
| Clear the attribute set. More...
bool | hasAttribute (const size_t pos) const
| Returns `true` if an attribute with this index exists. More...
bool | hasAttribute (const Name &attributeName) const
| Returns `true` if an attribute with this name exists. More...
AttributeArray::Ptr | appendAttribute (const Descriptor &expected, Descriptor::Ptr &replacement, const size_t pos, const Index strideOrTotalSize=1, const bool constantStride=true, const Metadata *metadata=nullptr, const AttributeArray::ScopedRegistryLock *lock=nullptr)
| Append an attribute to the leaf. More...
void | dropAttributes (const std::vector< size_t > &pos, const Descriptor &expected, Descriptor::Ptr &replacement)
| Drop list of attributes. More...
void | reorderAttributes (const Descriptor::Ptr &replacement)
| Reorder attribute set. More...
void | renameAttributes (const Descriptor &expected, Descriptor::Ptr &replacement)
| Rename attributes in attribute set (order must remain the same). More...
void | compactAttributes ()
| Compact all attributes in attribute set. More...
void | replaceAttributeSet (AttributeSet *attributeSet, bool allowMismatchingDescriptors=false)
| Replace the underlying attribute set with the given attributeSet. More...
void | resetDescriptor (const Descriptor::Ptr &replacement)
| Replace the descriptor with a new one The new Descriptor must exactly match the old one. More...
void | setOffsets (const std::vector< ValueType > &offsets, const bool updateValueMask=true)
| Sets all of the voxel offset values on this leaf, from the given vector of offsets. If updateValueMask is true, then the active value mask will be updated so voxels with points are active and empty voxels are inactive. More...
void | validateOffsets () const
| Throws an error if the voxel values on this leaf are not monotonically increasing or within the bounds of the attribute arrays. More...
AttributeArray & | attributeArray (const size_t pos)
| Read-write attribute array reference from index. More...
const AttributeArray & | attributeArray (const size_t pos) const
const AttributeArray & | constAttributeArray (const size_t pos) const
AttributeArray & | attributeArray (const Name &attributeName)
| Read-write attribute array reference from name. More...
const AttributeArray & | attributeArray (const Name &attributeName) const
const AttributeArray & | constAttributeArray (const Name &attributeName) const
GroupHandle | groupHandle (const AttributeSet::Descriptor::GroupIndex &index) const
| } More...
GroupHandle | groupHandle (const Name &group) const
| Read-only group handle from group name. More...
GroupWriteHandle | groupWriteHandle (const AttributeSet::Descriptor::GroupIndex &index)
| Read-write group handle from group index. More...
GroupWriteHandle | groupWriteHandle (const Name &name)
| Read-write group handle from group name. More...
Index64 | pointCount () const
| Compute the total point count for the leaf. More...
Index64 | onPointCount () const
| Compute the total active (on) point count for the leaf. More...
Index64 | offPointCount () const
| Compute the total inactive (off) point count for the leaf. More...
Index64 | groupPointCount (const Name &groupName) const
| Compute the point count in a specific group for the leaf. More...
void | updateValueMask ()
| Activate voxels with non-zero points, deactivate voxels with zero points. More...
void | setOffsetOn (Index offset, const ValueType &val)
void | setOffsetOnly (Index offset, const ValueType &val)
template<typename OtherType , Index OtherLog2Dim>
bool | hasSameTopology (const PointDataLeafNode< OtherType, OtherLog2Dim > *other) const
| Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node. More...
bool | operator== (const PointDataLeafNode &other) const
bool | operator!= (const PointDataLeafNode &other) const
void | addLeaf (PointDataLeafNode *)
template<typename AccessorT >
void | addLeafAndCache (PointDataLeafNode *, AccessorT &)
PointDataLeafNode * | touchLeaf (const Coord &)
| Return a pointer to this node. More...
template<typename AccessorT >
PointDataLeafNode * | touchLeafAndCache (const Coord &, AccessorT &)
template<typename NodeT , typename AccessorT >
NodeT * | probeNodeAndCache (const Coord &, AccessorT &)
PointDataLeafNode * | probeLeaf (const Coord &)
template<typename AccessorT >
PointDataLeafNode * | probeLeafAndCache (const Coord &, AccessorT &)
const PointDataLeafNode * | probeConstLeaf (const Coord &) const
| Return a `const` pointer to this node. More...
template<typename AccessorT >
const PointDataLeafNode * | probeConstLeafAndCache (const Coord &, AccessorT &) const
template<typename AccessorT >
const PointDataLeafNode * | probeLeafAndCache (const Coord &, AccessorT &) const
const PointDataLeafNode * | probeLeaf (const Coord &) const
template<typename NodeT , typename AccessorT >
const NodeT * | probeConstNodeAndCache (const Coord &, AccessorT &) const
void | readTopology (std::istream &is, bool fromHalf=false)
void | writeTopology (std::ostream &os, bool toHalf=false) const
Index | buffers () const
void | readBuffers (std::istream &is, bool fromHalf=false)
void | readBuffers (std::istream &is, const CoordBBox &, bool fromHalf=false)
void | writeBuffers (std::ostream &os, bool toHalf=false) const
Index64 | memUsage () const
void | evalActiveBoundingBox (CoordBBox &bbox, bool visitVoxels=true) const
CoordBBox | getNodeBoundingBox () const
| Return the bounding box of this node, i.e., the full index space spanned by this leaf node. More...
void | assertNonmodifiable ()
void | assertNonModifiableUnlessZero (const ValueType &value)
void | setActiveState (const Coord &xyz, bool on)
void | setActiveState (Index offset, bool on)
void | setValueOnly (const Coord &, const ValueType &)
void | setValueOnly (Index, const ValueType &)
void | setValueOff (const Coord &xyz)
void | setValueOff (Index offset)
void | setValueOff (const Coord &, const ValueType &)
void | setValueOff (Index, const ValueType &)
void | setValueOn (const Coord &xyz)
void | setValueOn (Index offset)
void | setValueOn (const Coord &, const ValueType &)
void | setValueOn (Index, const ValueType &)
void | setValue (const Coord &, const ValueType &)
void | setValuesOn ()
void | setValuesOff ()
template<typename ModifyOp >
void | modifyValue (Index, const ModifyOp &)
template<typename ModifyOp >
void | modifyValue (const Coord &, const ModifyOp &)
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &, const ModifyOp &)
void | clip (const CoordBBox &, const ValueType &value)
void | fill (const CoordBBox &, const ValueType &, bool)
void | fill (const ValueType &value)
void | fill (const ValueType &, bool)
template<typename AccessorT >
void | setValueOnlyAndCache (const Coord &, const ValueType &, AccessorT &)
template<typename ModifyOp , typename AccessorT >
void | modifyValueAndActiveStateAndCache (const Coord &, const ModifyOp &, AccessorT &)
template<typename AccessorT >
void | setValueOffAndCache (const Coord &, const ValueType &, AccessorT &)
template<typename AccessorT >
void | setActiveStateAndCache (const Coord &xyz, bool on, AccessorT &parent)
void | resetBackground (const ValueType &, const ValueType &newBackground)
void | signedFloodFill (const ValueType &)
void | signedFloodFill (const ValueType &, const ValueType &)
void | negate ()
ValueVoxelCIter | beginValueVoxel (const Coord &ijk) const
| Leaf value voxel iterator. More...
IndexAllIter | beginIndexAll () const
| Leaf index iterator. More...
IndexOnIter | beginIndexOn () const
IndexOffIter | beginIndexOff () const
template<typename IterT , typename FilterT >
IndexIter< IterT, FilterT > | beginIndex (const FilterT &filter) const
template<typename FilterT >
IndexIter< ValueAllCIter, FilterT > | beginIndexAll (const FilterT &filter) const
| Filtered leaf index iterator. More...
template<typename FilterT >
IndexIter< ValueOnCIter, FilterT > | beginIndexOn (const FilterT &filter) const
template<typename FilterT >
IndexIter< ValueOffCIter, FilterT > | beginIndexOff (const FilterT &filter) const
IndexVoxelIter | beginIndexVoxel (const Coord &ijk) const
| Leaf index iterator from voxel. More...
template<typename FilterT >
IndexIter< ValueVoxelCIter, FilterT > | beginIndexVoxel (const Coord &ijk, const FilterT &filter) const
| Filtered leaf index iterator from voxel. More...
ValueOnCIter | cbeginValueOn () const
ValueOnCIter | beginValueOn () const
ValueOnIter | beginValueOn ()
ValueOffCIter | cbeginValueOff () const
ValueOffCIter | beginValueOff () const
ValueOffIter | beginValueOff ()
ValueAllCIter | cbeginValueAll () const
ValueAllCIter | beginValueAll () const
ValueAllIter | beginValueAll ()
ValueOnCIter | cendValueOn () const
ValueOnCIter | endValueOn () const
ValueOnIter | endValueOn ()
ValueOffCIter | cendValueOff () const
ValueOffCIter | endValueOff () const
ValueOffIter | endValueOff ()
ValueAllCIter | cendValueAll () const
ValueAllCIter | endValueAll () const
ValueAllIter | endValueAll ()
ChildOnCIter | cbeginChildOn () const
ChildOnCIter | beginChildOn () const
ChildOnIter | beginChildOn ()
ChildOffCIter | cbeginChildOff () const
ChildOffCIter | beginChildOff () const
ChildOffIter | beginChildOff ()
ChildAllCIter | cbeginChildAll () const
ChildAllCIter | beginChildAll () const
ChildAllIter | beginChildAll ()
ChildOnCIter | cendChildOn () const
ChildOnCIter | endChildOn () const
ChildOnIter | endChildOn ()
ChildOffCIter | cendChildOff () const
ChildOffCIter | endChildOff () const
ChildOffIter | endChildOff ()
ChildAllCIter | cendChildAll () const
ChildAllCIter | endChildAll () const
ChildAllIter | endChildAll ()
template<typename ValueIterT , typename FilterT >
IndexIter< ValueIterT, FilterT > | beginIndex (const FilterT &filter) const

## Static Public Attributes
static const Index | LOG2DIM
static const Index | TOTAL
static const Index | DIM
static const Index | NUM_VALUES
static const Index | NUM_VOXELS
static const Index | SIZE
static const Index | LEVEL

## Protected Types
using | ChildOn = typename BaseLeaf::ChildOn
using | ChildOff = typename BaseLeaf::ChildOff
using | ChildAll = typename BaseLeaf::ChildAll
using | MaskOnIterator = typename NodeMaskType::OnIterator
using | MaskOffIterator = typename NodeMaskType::OffIterator
using | MaskDenseIterator = typename NodeMaskType::DenseIterator

## Friends
class | ::TestPointDataLeaf
template<typename , Index >
class | PointDataLeafNode
class | tree::IteratorBase< MaskOnIterator, PointDataLeafNode >
class | tree::IteratorBase< MaskOffIterator, PointDataLeafNode >
class | tree::IteratorBase< MaskDenseIterator, PointDataLeafNode >

## Member Typedef Documentation

## ◆ BaseLeaf

using BaseLeaf = tree::LeafNode<T, Log2Dim>

## ◆ ChildAll

using ChildAll = typename BaseLeaf::ChildAll
| protected

## ◆ ChildAllCIter

using ChildAllCIter = typename BaseLeaf::template DenseIter< const PointDataLeafNode, const ValueType, ChildAll>

## ◆ ChildAllIter

using ChildAllIter = typename BaseLeaf::template DenseIter< PointDataLeafNode, ValueType, ChildAll>

## ◆ ChildOff

using ChildOff = typename BaseLeaf::ChildOff
| protected

## ◆ ChildOffCIter

using ChildOffCIter = typename BaseLeaf::template ChildIter< MaskOffIterator, const PointDataLeafNode, ChildOff>

## ◆ ChildOffIter

using ChildOffIter = typename BaseLeaf::template ChildIter< MaskOffIterator, PointDataLeafNode, ChildOff>

## ◆ ChildOn

using ChildOn = typename BaseLeaf::ChildOn
| protected

## ◆ ChildOnCIter

using ChildOnCIter = typename BaseLeaf::template ChildIter< MaskOnIterator, const PointDataLeafNode, ChildOn>

## ◆ ChildOnIter

using ChildOnIter = typename BaseLeaf::template ChildIter< MaskOnIterator, PointDataLeafNode, ChildOn>

## ◆ Descriptor

using Descriptor = AttributeSet::Descriptor

## ◆ IndexAllIter

using IndexAllIter = IndexIter<ValueAllCIter, NullFilter>

## ◆ IndexArray

using IndexArray = std::vector<ValueType>

## ◆ IndexOffIter

using IndexOffIter = IndexIter<ValueOffCIter, NullFilter>

## ◆ IndexOnIter

using IndexOnIter = IndexIter<ValueOnCIter, NullFilter>

## ◆ IndexVoxelIter

using IndexVoxelIter = IndexIter<ValueVoxelCIter, NullFilter>

## ◆ LeafNodeType

using LeafNodeType = PointDataLeafNode<T, Log2Dim>

## ◆ MaskDenseIterator

using MaskDenseIterator = typename NodeMaskType::DenseIterator
| protected

## ◆ MaskOffIterator

using MaskOffIterator = typename NodeMaskType::OffIterator
| protected

## ◆ MaskOnIterator

using MaskOnIterator = typename NodeMaskType::OnIterator
| protected

## ◆ NodeMaskType

using NodeMaskType = util::NodeMask<Log2Dim>

## ◆ Ptr

using Ptr = std::shared_ptr<PointDataLeafNode>

## ◆ ValueAll

using ValueAll = typename BaseLeaf::ValueAll

## ◆ ValueAllCIter

using ValueAllCIter = typename BaseLeaf::template ValueIter< MaskDenseIterator,const PointDataLeafNode,const ValueType,ValueAll>

## ◆ ValueAllIter

using ValueAllIter = typename BaseLeaf::template ValueIter< MaskDenseIterator, PointDataLeafNode, const ValueType, ValueAll>

## ◆ ValueOff

using ValueOff = typename BaseLeaf::ValueOff

## ◆ ValueOffCIter

using ValueOffCIter = typename BaseLeaf::template ValueIter< MaskOffIterator,const PointDataLeafNode,const ValueType,ValueOff>

## ◆ ValueOffIter

using ValueOffIter = typename BaseLeaf::template ValueIter< MaskOffIterator, PointDataLeafNode, const ValueType, ValueOff>

## ◆ ValueOn

using ValueOn = typename BaseLeaf::ValueOn

## ◆ ValueOnCIter

using ValueOnCIter = typename BaseLeaf::template ValueIter< MaskOnIterator, const PointDataLeafNode, const ValueType, ValueOn>

## ◆ ValueOnIter

using ValueOnIter = typename BaseLeaf::template ValueIter< MaskOnIterator, PointDataLeafNode, const ValueType, ValueOn>

## ◆ ValueType

using ValueType = T

## ◆ ValueTypePair

using ValueTypePair = std::pair<ValueType, ValueType>

## Constructor & Destructor Documentation

## ◆ PointDataLeafNode() [1/8]

PointDataLeafNode | ( |  | ) |
| inline

Default constructor.

## ◆ ~PointDataLeafNode()

~PointDataLeafNode | ( |  | ) |
| default

## ◆ PointDataLeafNode() [2/8]

PointDataLeafNode | ( | const PointDataLeafNode< T, Log2Dim > & | other | ) |
| inlineexplicit

Construct using deep copy of other PointDataLeafNode.

## ◆ PointDataLeafNode() [3/8]

PointDataLeafNode | ( | const Coord & | coords,
|  | const T & | value = `zeroVal<T>()`,
|  | bool | active = `false`
| ) |  |
| inlineexplicit

Construct using supplied origin, value and active status.

## ◆ PointDataLeafNode() [4/8]

PointDataLeafNode | ( | const PointDataLeafNode< T, Log2Dim > & | other,
|  | const Coord & | coords,
|  | const T & | value = `zeroVal<T>()`,
|  | bool | active = `false`
| ) |  |
| inline

Construct using supplied origin, value and active status use attribute map from another PointDataLeafNode

## ◆ PointDataLeafNode() [5/8]

PointDataLeafNode | ( | const tools::PointIndexLeafNode< OtherValueType, Log2Dim > & | other | ) |
| inline

## ◆ PointDataLeafNode() [6/8]

PointDataLeafNode | ( | const tree::LeafNode< ValueType, Log2Dim > & | other,
|  | const T & | value,
|  | TopologyCopy |
| ) |  |
| inline

## ◆ PointDataLeafNode() [7/8]

PointDataLeafNode | ( | const tree::LeafNode< ValueType, Log2Dim > & | other,
|  | const T & | ,
|  | const T & | ,
|  | TopologyCopy |
| ) |  |
| inline

## ◆ PointDataLeafNode() [8/8]

PointDataLeafNode | ( | PartialCreate | ,
|  | const Coord & | coords,
|  | const T & | value = `zeroVal<T>()`,
|  | bool | active = `false`
| ) |  |
| inline

## Member Function Documentation

## ◆ addLeaf()

void addLeaf | ( | PointDataLeafNode< T, Log2Dim > * |  | ) |
| inline

## ◆ addLeafAndCache()

void addLeafAndCache | ( | PointDataLeafNode< T, Log2Dim > * | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ appendAttribute()

AttributeArray::Ptr appendAttribute | ( | const Descriptor & | expected,
|  | Descriptor::Ptr & | replacement,
|  | const size_t | pos,
|  | const Index | strideOrTotalSize = `1`,
|  | const bool | constantStride = `true`,
|  | const Metadata * | metadata = `nullptr`,
|  | const AttributeArray::ScopedRegistryLock * | lock = `nullptr`
| ) |  |
| inline

Append an attribute to the leaf.

Parameters

  expected | Existing descriptor is expected to match this parameter.
  replacement | New descriptor to replace the existing one.
  pos | Index of the new attribute in the descriptor replacement.
  strideOrTotalSize | Stride of the attribute array (if constantStride), total size otherwise
  constantStride | if `false`, stride is interpreted as total size of the array
  metadata | optional default value metadata
  lock | an optional scoped registry lock to avoid contention

## ◆ assertNonmodifiable()

void assertNonmodifiable | ( |  | ) |
| inline

## ◆ assertNonModifiableUnlessZero()

void assertNonModifiableUnlessZero | ( | const ValueType & | value | ) |
| inline

## ◆ attributeArray() [1/4]

AttributeArray & attributeArray | ( | const Name & | attributeName | ) |
| inline

Read-write attribute array reference from name.

} Attribute arrays can be shared across leaf nodes, so non-const access will deep-copy the array to make it unique. Always prefer accessing const arrays where possible to eliminate this copying. {

## ◆ attributeArray() [2/4]

const AttributeArray & attributeArray | ( | const Name & | attributeName | ) | const
| inline

## ◆ attributeArray() [3/4]

AttributeArray & attributeArray | ( | const size_t | pos | ) |
| inline

Read-write attribute array reference from index.

Attribute arrays can be shared across leaf nodes, so non-const access will deep-copy the array to make it unique. Always prefer accessing const arrays where possible to eliminate this copying. {

## ◆ attributeArray() [4/4]

const AttributeArray & attributeArray | ( | const size_t | pos | ) | const
| inline

## ◆ attributeSet()

const AttributeSet& attributeSet | ( |  | ) | const
| inline

Retrieve the attribute set.

## ◆ beginChildAll() [1/2]

ChildAllIter beginChildAll | ( |  | ) |
| inline

## ◆ beginChildAll() [2/2]

ChildAllCIter beginChildAll | ( |  | ) | const
| inline

## ◆ beginChildOff() [1/2]

ChildOffIter beginChildOff | ( |  | ) |
| inline

## ◆ beginChildOff() [2/2]

ChildOffCIter beginChildOff | ( |  | ) | const
| inline

## ◆ beginChildOn() [1/2]

ChildOnIter beginChildOn | ( |  | ) |
| inline

## ◆ beginChildOn() [2/2]

ChildOnCIter beginChildOn | ( |  | ) | const
| inline

## ◆ beginIndex() [1/2]

IndexIter<IterT, FilterT> beginIndex | ( | const FilterT & | filter | ) | const

## ◆ beginIndex() [2/2]

IndexIter<ValueIterT, FilterT> beginIndex | ( | const FilterT & | filter | ) | const
| inline

## ◆ beginIndexAll() [1/2]

IndexAllIter beginIndexAll | ( |  | ) | const
| inline

Leaf index iterator.

## ◆ beginIndexAll() [2/2]

IndexIter<ValueAllCIter, FilterT> beginIndexAll | ( | const FilterT & | filter | ) | const
| inline

Filtered leaf index iterator.

## ◆ beginIndexOff() [1/2]

IndexOffIter beginIndexOff | ( |  | ) | const
| inline

## ◆ beginIndexOff() [2/2]

IndexIter<ValueOffCIter, FilterT> beginIndexOff | ( | const FilterT & | filter | ) | const
| inline

## ◆ beginIndexOn() [1/2]

IndexOnIter beginIndexOn | ( |  | ) | const
| inline

## ◆ beginIndexOn() [2/2]

IndexIter<ValueOnCIter, FilterT> beginIndexOn | ( | const FilterT & | filter | ) | const
| inline

## ◆ beginIndexVoxel() [1/2]

PointDataLeafNode< T, Log2Dim >::IndexVoxelIter beginIndexVoxel | ( | const Coord & | ijk | ) | const
| inline

Leaf index iterator from voxel.

## ◆ beginIndexVoxel() [2/2]

IndexIter< ValueVoxelCIter, FilterT > beginIndexVoxel | ( | const Coord & | ijk,
|  | const FilterT & | filter
| ) |  | const
| inline

Filtered leaf index iterator from voxel.

## ◆ beginValueAll() [1/2]

ValueAllIter beginValueAll | ( |  | ) |
| inline

## ◆ beginValueAll() [2/2]

ValueAllCIter beginValueAll | ( |  | ) | const
| inline

## ◆ beginValueOff() [1/2]

ValueOffIter beginValueOff | ( |  | ) |
| inline

## ◆ beginValueOff() [2/2]

ValueOffCIter beginValueOff | ( |  | ) | const
| inline

## ◆ beginValueOn() [1/2]

ValueOnIter beginValueOn | ( |  | ) |
| inline

## ◆ beginValueOn() [2/2]

ValueOnCIter beginValueOn | ( |  | ) | const
| inline

## ◆ beginValueVoxel()

ValueVoxelCIter beginValueVoxel | ( | const Coord & | ijk | ) | const
| inline

Leaf value voxel iterator.

## ◆ buffers()

Index buffers
| inline

## ◆ cbeginChildAll()

ChildAllCIter cbeginChildAll | ( |  | ) | const
| inline

## ◆ cbeginChildOff()

ChildOffCIter cbeginChildOff | ( |  | ) | const
| inline

## ◆ cbeginChildOn()

ChildOnCIter cbeginChildOn | ( |  | ) | const
| inline

## ◆ cbeginValueAll()

ValueAllCIter cbeginValueAll | ( |  | ) | const
| inline

## ◆ cbeginValueOff()

ValueOffCIter cbeginValueOff | ( |  | ) | const
| inline

## ◆ cbeginValueOn()

ValueOnCIter cbeginValueOn | ( |  | ) | const
| inline

## ◆ cendChildAll()

ChildAllCIter cendChildAll | ( |  | ) | const
| inline

## ◆ cendChildOff()

ChildOffCIter cendChildOff | ( |  | ) | const
| inline

## ◆ cendChildOn()

ChildOnCIter cendChildOn | ( |  | ) | const
| inline

## ◆ cendValueAll()

ValueAllCIter cendValueAll | ( |  | ) | const
| inline

## ◆ cendValueOff()

ValueOffCIter cendValueOff | ( |  | ) | const
| inline

## ◆ cendValueOn()

ValueOnCIter cendValueOn | ( |  | ) | const
| inline

## ◆ clearAttributes()

void clearAttributes | ( | const bool | updateValueMask = `true`,
|  | const AttributeArray::ScopedRegistryLock * | lock = `nullptr`
| ) |  |
| inline

Clear the attribute set.

## ◆ clip()

void clip | ( | const CoordBBox & | ,
|  | const ValueType & | value
| ) |  |
| inline

## ◆ compactAttributes()

void compactAttributes
| inline

Compact all attributes in attribute set.

## ◆ constAttributeArray() [1/2]

const AttributeArray & constAttributeArray | ( | const Name & | attributeName | ) | const
| inline

## ◆ constAttributeArray() [2/2]

const AttributeArray & constAttributeArray | ( | const size_t | pos | ) | const
| inline

## ◆ dropAttributes()

void dropAttributes | ( | const std::vector< size_t > & | pos,
|  | const Descriptor & | expected,
|  | Descriptor::Ptr & | replacement
| ) |  |
| inline

Drop list of attributes.

Parameters

  pos | vector of attribute indices to drop
  expected | Existing descriptor is expected to match this parameter.
  replacement | New descriptor to replace the existing one.

## ◆ endChildAll() [1/2]

ChildAllIter endChildAll | ( |  | ) |
| inline

## ◆ endChildAll() [2/2]

ChildAllCIter endChildAll | ( |  | ) | const
| inline

## ◆ endChildOff() [1/2]

ChildOffIter endChildOff | ( |  | ) |
| inline

## ◆ endChildOff() [2/2]

ChildOffCIter endChildOff | ( |  | ) | const
| inline

## ◆ endChildOn() [1/2]

ChildOnIter endChildOn | ( |  | ) |
| inline

## ◆ endChildOn() [2/2]

ChildOnCIter endChildOn | ( |  | ) | const
| inline

## ◆ endValueAll() [1/2]

ValueAllIter endValueAll | ( |  | ) |
| inline

## ◆ endValueAll() [2/2]

ValueAllCIter endValueAll | ( |  | ) | const
| inline

## ◆ endValueOff() [1/2]

ValueOffIter endValueOff | ( |  | ) |
| inline

## ◆ endValueOff() [2/2]

ValueOffCIter endValueOff | ( |  | ) | const
| inline

## ◆ endValueOn() [1/2]

ValueOnIter endValueOn | ( |  | ) |
| inline

## ◆ endValueOn() [2/2]

ValueOnCIter endValueOn | ( |  | ) | const
| inline

## ◆ evalActiveBoundingBox()

void evalActiveBoundingBox | ( | CoordBBox & | bbox,
|  | bool | visitVoxels = `true`
| ) |  | const
| inline

## ◆ fill() [1/3]

void fill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active
| ) |  |
| inline

## ◆ fill() [2/3]

void fill | ( | const ValueType & | value,
|  | bool | active
| ) |  |
| inline

## ◆ fill() [3/3]

void fill | ( | const ValueType & | value | ) |
| inline

## ◆ getNodeBoundingBox()

CoordBBox getNodeBoundingBox
| inline

Return the bounding box of this node, i.e., the full index space spanned by this leaf node.

## ◆ groupHandle() [1/2]

GroupHandle groupHandle | ( | const AttributeSet::Descriptor::GroupIndex & | index | ) | const
| inline

}

Read-only group handle from group index

## ◆ groupHandle() [2/2]

GroupHandle groupHandle | ( | const Name & | group | ) | const
| inline

Read-only group handle from group name.

## ◆ groupPointCount()

Index64 groupPointCount | ( | const Name & | groupName | ) | const
| inline

Compute the point count in a specific group for the leaf.

## ◆ groupWriteHandle() [1/2]

GroupWriteHandle groupWriteHandle | ( | const AttributeSet::Descriptor::GroupIndex & | index | ) |
| inline

Read-write group handle from group index.

## ◆ groupWriteHandle() [2/2]

GroupWriteHandle groupWriteHandle | ( | const Name & | name | ) |
| inline

Read-write group handle from group name.

## ◆ hasAttribute() [1/2]

bool hasAttribute | ( | const Name & | attributeName | ) | const
| inline

Returns `true` if an attribute with this name exists.

Parameters

  attributeName | Name of the attribute

## ◆ hasAttribute() [2/2]

bool hasAttribute | ( | const size_t | pos | ) | const
| inline

Returns `true` if an attribute with this index exists.

Parameters

  pos | Index of the attribute

## ◆ hasSameTopology()

bool hasSameTopology | ( | const PointDataLeafNode< OtherType, OtherLog2Dim > * | other | ) | const
| inline

Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.

## ◆ initializeAttributes()

void initializeAttributes | ( | const Descriptor::Ptr & | descriptor,
|  | const Index | arrayLength,
|  | const AttributeArray::ScopedRegistryLock * | lock = `nullptr`
| ) |  |
| inline

Create a new attribute set. Existing attributes will be removed.

## ◆ memUsage()

Index64 memUsage
| inline

## ◆ modifyValue() [1/2]

void modifyValue | ( | const Coord & | ,
|  | const ModifyOp & |
| ) |  |
| inline

## ◆ modifyValue() [2/2]

void modifyValue | ( | Index | ,
|  | const ModifyOp & |
| ) |  |
| inline

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | ,
|  | const ModifyOp & |
| ) |  |
| inline

## ◆ modifyValueAndActiveStateAndCache()

void modifyValueAndActiveStateAndCache | ( | const Coord & | ,
|  | const ModifyOp & | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ negate()

void negate | ( |  | ) |
| inline

## ◆ offPointCount()

Index64 offPointCount
| inline

Compute the total inactive (off) point count for the leaf.

## ◆ onPointCount()

Index64 onPointCount
| inline

Compute the total active (on) point count for the leaf.

## ◆ operator!=()

bool operator!= | ( | const PointDataLeafNode< T, Log2Dim > & | other | ) | const
| inline

## ◆ operator==()

bool operator== | ( | const PointDataLeafNode< T, Log2Dim > & | other | ) | const
| inline

Check for buffer, state and origin equivalence first. If this returns true, do a deeper comparison on the attribute set to check

## ◆ pointCount()

Index64 pointCount
| inline

Compute the total point count for the leaf.

## ◆ probeConstLeaf()

const PointDataLeafNode* probeConstLeaf | ( | const Coord & |  | ) | const
| inline

Return a `const` pointer to this node.

## ◆ probeConstLeafAndCache()

const PointDataLeafNode* probeConstLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

## ◆ probeConstNodeAndCache()

const NodeT* probeConstNodeAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

## ◆ probeLeaf() [1/2]

PointDataLeafNode* probeLeaf | ( | const Coord & |  | ) |
| inline

## ◆ probeLeaf() [2/2]

const PointDataLeafNode* probeLeaf | ( | const Coord & |  | ) | const
| inline

## ◆ probeLeafAndCache() [1/2]

PointDataLeafNode* probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ probeLeafAndCache() [2/2]

const PointDataLeafNode* probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  | const
| inline

## ◆ probeNodeAndCache()

NodeT* probeNodeAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ readBuffers() [1/2]

void readBuffers | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ readBuffers() [2/2]

void readBuffers | ( | std::istream & | is,
|  | const CoordBBox & | ,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ readTopology()

void readTopology | ( | std::istream & | is,
|  | bool | fromHalf = `false`
| ) |  |
| inline

## ◆ renameAttributes()

void renameAttributes | ( | const Descriptor & | expected,
|  | Descriptor::Ptr & | replacement
| ) |  |
| inline

Rename attributes in attribute set (order must remain the same).

Parameters

  expected | Existing descriptor is expected to match this parameter.
  replacement | New descriptor to replace the existing one.

## ◆ reorderAttributes()

void reorderAttributes | ( | const Descriptor::Ptr & | replacement | ) |
| inline

Reorder attribute set.

Parameters

  replacement | New descriptor to replace the existing one.

## ◆ replaceAttributeSet()

void replaceAttributeSet | ( | AttributeSet * | attributeSet,
|  | bool | allowMismatchingDescriptors = `false`
| ) |  |
| inline

Replace the underlying attribute set with the given attributeSet.

This leaf will assume ownership of the given attribute set. The descriptors must match and the voxel offsets values will need updating if the point order is different.

Exceptions

  ValueError | if allowMismatchingDescriptors is `false` and the descriptors do not match

## ◆ resetBackground()

void resetBackground | ( | const ValueType & | ,
|  | const ValueType & | newBackground
| ) |  |
| inline

## ◆ resetDescriptor()

void resetDescriptor | ( | const Descriptor::Ptr & | replacement | ) |
| inline

Replace the descriptor with a new one The new Descriptor must exactly match the old one.

## ◆ setActiveState() [1/2]

void setActiveState | ( | const Coord & | xyz,
|  | bool | on
| ) |  |
| inline

## ◆ setActiveState() [2/2]

void setActiveState | ( | Index | offset,
|  | bool | on
| ) |  |
| inline

## ◆ setActiveStateAndCache()

void setActiveStateAndCache | ( | const Coord & | xyz,
|  | bool | on,
|  | AccessorT & | parent
| ) |  |
| inline

## ◆ setOffsetOn()

void setOffsetOn | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

## ◆ setOffsetOnly()

void setOffsetOnly | ( | Index | offset,
|  | const ValueType & | val
| ) |  |
| inline

## ◆ setOffsets()

void setOffsets | ( | const std::vector< ValueType > & | offsets,
|  | const bool | updateValueMask = `true`
| ) |  |
| inline

Sets all of the voxel offset values on this leaf, from the given vector of offsets. If updateValueMask is true, then the active value mask will be updated so voxels with points are active and empty voxels are inactive.

## ◆ setValue()

void setValue | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOff() [1/4]

void setValueOff | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOff() [2/4]

void setValueOff | ( | const Coord & | xyz | ) |
| inline

## ◆ setValueOff() [3/4]

void setValueOff | ( | Index | offset | ) |
| inline

## ◆ setValueOff() [4/4]

void setValueOff | ( | Index | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOffAndCache()

void setValueOffAndCache | ( | const Coord & | ,
|  | const ValueType & | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ setValueOn() [1/4]

void setValueOn | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOn() [2/4]

void setValueOn | ( | const Coord & | xyz | ) |
| inline

## ◆ setValueOn() [3/4]

void setValueOn | ( | Index | offset | ) |
| inline

## ◆ setValueOn() [4/4]

void setValueOn | ( | Index | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOnly() [1/2]

void setValueOnly | ( | const Coord & | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOnly() [2/2]

void setValueOnly | ( | Index | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ setValueOnlyAndCache()

void setValueOnlyAndCache | ( | const Coord & | ,
|  | const ValueType & | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ setValuesOff()

void setValuesOff | ( |  | ) |
| inline

## ◆ setValuesOn()

void setValuesOn | ( |  | ) |
| inline

## ◆ signedFloodFill() [1/2]

void signedFloodFill | ( | const ValueType & |  | ) |
| inline

## ◆ signedFloodFill() [2/2]

void signedFloodFill | ( | const ValueType & | ,
|  | const ValueType & |
| ) |  |
| inline

## ◆ stealAttributeSet()

AttributeSet::UniquePtr stealAttributeSet
| inline

Steal the attribute set, a new, empty attribute set is inserted in it's place.

## ◆ touchLeaf()

PointDataLeafNode* touchLeaf | ( | const Coord & |  | ) |
| inline

Return a pointer to this node.

## ◆ touchLeafAndCache()

PointDataLeafNode* touchLeafAndCache | ( | const Coord & | ,
|  | AccessorT & |
| ) |  |
| inline

## ◆ updateValueMask()

void updateValueMask
| inline

Activate voxels with non-zero points, deactivate voxels with zero points.

## ◆ validateOffsets()

void validateOffsets
| inline

Throws an error if the voxel values on this leaf are not monotonically increasing or within the bounds of the attribute arrays.

## ◆ writeBuffers()

void writeBuffers | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

## ◆ writeTopology()

void writeTopology | ( | std::ostream & | os,
|  | bool | toHalf = `false`
| ) |  | const
| inline

## Friends And Related Function Documentation

## ◆ ::TestPointDataLeaf

friend class ::TestPointDataLeaf
| friend

## ◆ PointDataLeafNode

friend class PointDataLeafNode
| friend

## ◆ tree::IteratorBase< MaskDenseIterator, PointDataLeafNode >

friend class tree::IteratorBase< MaskDenseIterator, PointDataLeafNode >
| friend

## ◆ tree::IteratorBase< MaskOffIterator, PointDataLeafNode >

friend class tree::IteratorBase< MaskOffIterator, PointDataLeafNode >
| friend

## ◆ tree::IteratorBase< MaskOnIterator, PointDataLeafNode >

friend class tree::IteratorBase< MaskOnIterator, PointDataLeafNode >
| friend

## Member Data Documentation

## ◆ DIM

const Index DIM
| static

## ◆ LEVEL

const Index LEVEL
| static

## ◆ LOG2DIM

const Index LOG2DIM
| static

## ◆ NUM_VALUES

const Index NUM_VALUES
| static

## ◆ NUM_VOXELS

const Index NUM_VOXELS
| static

## ◆ SIZE

const Index SIZE
| static

## ◆ TOTAL

const Index TOTAL
| static

The documentation for this class was generated from the following file:

- PointDataGrid.h